rm(list=ls())
# this solves a blup for genomic selection
a=matrix( scan('bl.txt'),nrow=1829,byrow=TRUE)
# extract design matrix for SNPs
X=a[,-(1:3)]
#extract data
y=a[,1]
# add design matrix for general mean
X=cbind(1,X)
neq=dim(X)[2]
# solve by Gauss Seidel
e=y
ahat=rep(0,neq)
xpx=rep(0,neq)
epsit=rep(0,1)
vare=0.150
vara=9.09E-06
# thisis GSRU, legarra & Misztal, Journal of Dairy Science 2008
#set up diag(X'X)
for (i in 1:neq) {
  xpx[i]=crossprod(X[,i],X[,i])
}
mu=0
# do until convergence
for (iter in 1:1000) {
  #Gauss Seidel
  eps=0
  for (i in 1:neq){
    lhs=xpx[i]/vare
    if(i>1) lhs=lhs+1/vara
    rhs=crossprod(X[,i],e)/vare + xpx[i]/vare*ahat[i]
    val=rhs/lhs
    eps=eps+((val - ahat[i])**2)
    e = e - X[,i]*(val - ahat[i])
    ahat[i]=val
  }
  if(iter%%10==0) print(c(iter,eps))
  epsit[iter]=eps
  if(eps<1E-10) break
}
print(c(iter,eps,date()))
cor(y,y-e)    
    

